diff --git a/tests/qemuargv2xmldata/qemuargv2xml-machine-aeskeywrap-off-argv.args b/tests/qemuargv2xmldata/qemuargv2xml-machine-aeskeywrap-off-argv.args
index c1609b1..ed88352 100644
--- a/tests/qemuargv2xmldata/qemuargv2xml-machine-aeskeywrap-off-argv.args
+++ b/tests/qemuargv2xmldata/qemuargv2xml-machine-aeskeywrap-off-argv.args
@@ -15,6 +15,4 @@ QEMU_AUDIO_DRV=none \
 -nodefaults \
 -monitor unix:/tmp/test-monitor,server,nowait \
 -no-acpi \
--boot c \
--drive file=/dev/HostVG/QEMUGuest1,format=raw,if=virtio,index=0,\
-id=drive-virtio-disk0
+-boot c
diff --git a/tests/qemuargv2xmldata/qemuargv2xml-machine-aeskeywrap-off-argv.xml b/tests/qemuargv2xmldata/qemuargv2xml-machine-aeskeywrap-off-argv.xml
index 7ccdc67..7c100a7 100644
--- a/tests/qemuargv2xmldata/qemuargv2xml-machine-aeskeywrap-off-argv.xml
+++ b/tests/qemuargv2xmldata/qemuargv2xml-machine-aeskeywrap-off-argv.xml
@@ -14,11 +14,6 @@
   <on_crash>destroy</on_crash>
   <devices>
     <emulator>/usr/bin/qemu-system-s390x</emulator>
-    <disk type='block' device='disk'>
-      <driver name='qemu' type='raw'/>
-      <source dev='/dev/HostVG/QEMUGuest1'/>
-      <target dev='vda' bus='virtio'/>
-    </disk>
     <memballoon model='none'/>
     <panic model='s390'/>
   </devices>
diff --git a/tests/qemuargv2xmldata/qemuargv2xml-machine-aeskeywrap-on-argv.args b/tests/qemuargv2xmldata/qemuargv2xml-machine-aeskeywrap-on-argv.args
index 775b484..99f58f0 100644
--- a/tests/qemuargv2xmldata/qemuargv2xml-machine-aeskeywrap-on-argv.args
+++ b/tests/qemuargv2xmldata/qemuargv2xml-machine-aeskeywrap-on-argv.args
@@ -15,6 +15,4 @@ QEMU_AUDIO_DRV=none \
 -nodefaults \
 -monitor unix:/tmp/test-monitor,server,nowait \
 -no-acpi \
--boot c \
--drive file=/dev/HostVG/QEMUGuest1,format=raw,if=virtio,index=0,\
-id=drive-virtio-disk0
+-boot c
diff --git a/tests/qemuargv2xmldata/qemuargv2xml-machine-aeskeywrap-on-argv.xml b/tests/qemuargv2xmldata/qemuargv2xml-machine-aeskeywrap-on-argv.xml
index a02523d..94bb6b2 100644
--- a/tests/qemuargv2xmldata/qemuargv2xml-machine-aeskeywrap-on-argv.xml
+++ b/tests/qemuargv2xmldata/qemuargv2xml-machine-aeskeywrap-on-argv.xml
@@ -14,11 +14,6 @@
   <on_crash>destroy</on_crash>
   <devices>
     <emulator>/usr/bin/qemu-system-s390x</emulator>
-    <disk type='block' device='disk'>
-      <driver name='qemu' type='raw'/>
-      <source dev='/dev/HostVG/QEMUGuest1'/>
-      <target dev='vda' bus='virtio'/>
-    </disk>
     <memballoon model='none'/>
     <panic model='s390'/>
   </devices>
diff --git a/tests/qemuargv2xmldata/qemuargv2xml-machine-deakeywrap-off-argv.args b/tests/qemuargv2xmldata/qemuargv2xml-machine-deakeywrap-off-argv.args
index e35ab0f..2ffd45e 100644
--- a/tests/qemuargv2xmldata/qemuargv2xml-machine-deakeywrap-off-argv.args
+++ b/tests/qemuargv2xmldata/qemuargv2xml-machine-deakeywrap-off-argv.args
@@ -15,6 +15,4 @@ QEMU_AUDIO_DRV=none \
 -nodefaults \
 -monitor unix:/tmp/test-monitor,server,nowait \
 -no-acpi \
--boot c \
--drive file=/dev/HostVG/QEMUGuest1,format=raw,if=virtio,index=0,\
-id=drive-virtio-disk0
+-boot c
diff --git a/tests/qemuargv2xmldata/qemuargv2xml-machine-deakeywrap-off-argv.xml b/tests/qemuargv2xmldata/qemuargv2xml-machine-deakeywrap-off-argv.xml
index 7f0c871..a707ce3 100644
--- a/tests/qemuargv2xmldata/qemuargv2xml-machine-deakeywrap-off-argv.xml
+++ b/tests/qemuargv2xmldata/qemuargv2xml-machine-deakeywrap-off-argv.xml
@@ -14,11 +14,6 @@
   <on_crash>destroy</on_crash>
   <devices>
     <emulator>/usr/bin/qemu-system-s390x</emulator>
-    <disk type='block' device='disk'>
-      <driver name='qemu' type='raw'/>
-      <source dev='/dev/HostVG/QEMUGuest1'/>
-      <target dev='vda' bus='virtio'/>
-    </disk>
     <memballoon model='none'/>
     <panic model='s390'/>
   </devices>
diff --git a/tests/qemuargv2xmldata/qemuargv2xml-machine-deakeywrap-on-argv.args b/tests/qemuargv2xmldata/qemuargv2xml-machine-deakeywrap-on-argv.args
index 18dd415..c0102ed 100644
--- a/tests/qemuargv2xmldata/qemuargv2xml-machine-deakeywrap-on-argv.args
+++ b/tests/qemuargv2xmldata/qemuargv2xml-machine-deakeywrap-on-argv.args
@@ -15,6 +15,4 @@ QEMU_AUDIO_DRV=none \
 -nodefaults \
 -monitor unix:/tmp/test-monitor,server,nowait \
 -no-acpi \
--boot c \
--drive file=/dev/HostVG/QEMUGuest1,format=raw,if=virtio,index=0,\
-id=drive-virtio-disk0
+-boot c
diff --git a/tests/qemuargv2xmldata/qemuargv2xml-machine-deakeywrap-on-argv.xml b/tests/qemuargv2xmldata/qemuargv2xml-machine-deakeywrap-on-argv.xml
index d4721dc..41c464a 100644
--- a/tests/qemuargv2xmldata/qemuargv2xml-machine-deakeywrap-on-argv.xml
+++ b/tests/qemuargv2xmldata/qemuargv2xml-machine-deakeywrap-on-argv.xml
@@ -14,11 +14,6 @@
   <on_crash>destroy</on_crash>
   <devices>
     <emulator>/usr/bin/qemu-system-s390x</emulator>
-    <disk type='block' device='disk'>
-      <driver name='qemu' type='raw'/>
-      <source dev='/dev/HostVG/QEMUGuest1'/>
-      <target dev='vda' bus='virtio'/>
-    </disk>
     <memballoon model='none'/>
     <panic model='s390'/>
   </devices>
diff --git a/tests/qemuargv2xmldata/qemuargv2xml-machine-keywrap-none-argv.args b/tests/qemuargv2xmldata/qemuargv2xml-machine-keywrap-none-argv.args
index 283e9b3..0bf57fc 100644
--- a/tests/qemuargv2xmldata/qemuargv2xml-machine-keywrap-none-argv.args
+++ b/tests/qemuargv2xmldata/qemuargv2xml-machine-keywrap-none-argv.args
@@ -15,6 +15,4 @@ QEMU_AUDIO_DRV=none \
 -nodefaults \
 -monitor unix:/tmp/test-monitor,server,nowait \
 -no-acpi \
--boot c \
--drive file=/dev/HostVG/QEMUGuest1,format=raw,if=virtio,index=0,\
-id=drive-virtio-disk0
+-boot c
diff --git a/tests/qemuargv2xmldata/qemuargv2xml-machine-keywrap-none-argv.xml b/tests/qemuargv2xmldata/qemuargv2xml-machine-keywrap-none-argv.xml
index 5483040..0b0ce70 100644
--- a/tests/qemuargv2xmldata/qemuargv2xml-machine-keywrap-none-argv.xml
+++ b/tests/qemuargv2xmldata/qemuargv2xml-machine-keywrap-none-argv.xml
@@ -14,11 +14,6 @@
   <on_crash>destroy</on_crash>
   <devices>
     <emulator>/usr/bin/qemu-system-s390x</emulator>
-    <disk type='block' device='disk'>
-      <driver name='qemu' type='raw'/>
-      <source dev='/dev/HostVG/QEMUGuest1'/>
-      <target dev='vda' bus='virtio'/>
-    </disk>
     <memballoon model='none'/>
     <panic model='s390'/>
   </devices>