diff --git a/tests/domaincapsmock.c b/tests/domaincapsmock.c
index d8cf61685e..90e17c19f0 100644
--- a/tests/domaincapsmock.c
+++ b/tests/domaincapsmock.c
@@ -17,6 +17,17 @@
 #include <config.h>
 
 #include "virhostcpu.h"
+#ifdef WITH_LIBXL
+# include "libxl/libxl_capabilities.h"
+#endif
+
+#ifdef WITH_LIBXL
+bool
+libxlCapsHasPVUSB(void)
+{
+    return true;
+}
+#endif
 
 int
 virHostCPUGetKVMMaxVCPUs(void)
diff --git a/tests/domaincapsschemadata/libxl-xenfv-usb.xml b/tests/domaincapsschemadata/libxl-xenfv-usb.xml
deleted file mode 100644
index 29fe1f9aa3..0000000000
--- a/tests/domaincapsschemadata/libxl-xenfv-usb.xml
+++ /dev/null
@@ -1,78 +0,0 @@
-<domainCapabilities>
-  <path>/usr/bin/qemu-system-x86_64</path>
-  <domain>xen</domain>
-  <machine>xenfv</machine>
-  <arch>x86_64</arch>
-  <vcpu max='128'/>
-  <iothreads supported='no'/>
-  <os supported='yes'>
-    <loader supported='yes'>
-      <value>/usr/lib/xen/boot/hvmloader</value>
-      <value>/usr/lib/xen/boot/ovmf.bin</value>
-      <enum name='type'>
-        <value>rom</value>
-        <value>pflash</value>
-      </enum>
-      <enum name='readonly'>
-        <value>yes</value>
-      </enum>
-    </loader>
-  </os>
-  <cpu>
-    <mode name='host-passthrough' supported='no'/>
-    <mode name='host-model' supported='no'/>
-    <mode name='custom' supported='no'/>
-  </cpu>
-  <devices>
-    <disk supported='yes'>
-      <enum name='diskDevice'>
-        <value>disk</value>
-        <value>cdrom</value>
-      </enum>
-      <enum name='bus'>
-        <value>ide</value>
-        <value>scsi</value>
-        <value>xen</value>
-      </enum>
-    </disk>
-    <graphics supported='yes'>
-      <enum name='type'>
-        <value>sdl</value>
-        <value>vnc</value>
-        <value>spice</value>
-      </enum>
-    </graphics>
-    <video supported='yes'>
-      <enum name='modelType'>
-        <value>vga</value>
-        <value>cirrus</value>
-        <value>xen</value>
-      </enum>
-    </video>
-    <hostdev supported='yes'>
-      <enum name='mode'>
-        <value>subsystem</value>
-      </enum>
-      <enum name='startupPolicy'>
-        <value>default</value>
-        <value>mandatory</value>
-        <value>requisite</value>
-        <value>optional</value>
-      </enum>
-      <enum name='subsysType'>
-        <value>usb</value>
-        <value>pci</value>
-      </enum>
-      <enum name='capsType'/>
-      <enum name='pciBackend'>
-        <value>xen</value>
-      </enum>
-    </hostdev>
-  </devices>
-  <features>
-    <gic supported='no'/>
-    <vmcoreinfo supported='no'/>
-    <genid supported='no'/>
-    <sev supported='no'/>
-  </features>
-</domainCapabilities>
diff --git a/tests/domaincapsschemadata/libxl-xenfv.xml b/tests/domaincapsschemadata/libxl-xenfv.xml
index 5f318d5c4b..29fe1f9aa3 100644
--- a/tests/domaincapsschemadata/libxl-xenfv.xml
+++ b/tests/domaincapsschemadata/libxl-xenfv.xml
@@ -60,6 +60,7 @@
         <value>optional</value>
       </enum>
       <enum name='subsysType'>
+        <value>usb</value>
         <value>pci</value>
       </enum>
       <enum name='capsType'/>
diff --git a/tests/domaincapsschemadata/libxl-xenpv-usb.xml b/tests/domaincapsschemadata/libxl-xenpv-usb.xml
deleted file mode 100644
index b9f3ca736b..0000000000
--- a/tests/domaincapsschemadata/libxl-xenpv-usb.xml
+++ /dev/null
@@ -1,68 +0,0 @@
-<domainCapabilities>
-  <path>/usr/bin/qemu-system-x86_64</path>
-  <domain>xen</domain>
-  <machine>xenpv</machine>
-  <arch>x86_64</arch>
-  <vcpu max='512'/>
-  <iothreads supported='no'/>
-  <os supported='yes'>
-    <loader supported='no'/>
-  </os>
-  <cpu>
-    <mode name='host-passthrough' supported='no'/>
-    <mode name='host-model' supported='no'/>
-    <mode name='custom' supported='no'/>
-  </cpu>
-  <devices>
-    <disk supported='yes'>
-      <enum name='diskDevice'>
-        <value>disk</value>
-        <value>cdrom</value>
-      </enum>
-      <enum name='bus'>
-        <value>ide</value>
-        <value>scsi</value>
-        <value>xen</value>
-      </enum>
-    </disk>
-    <graphics supported='yes'>
-      <enum name='type'>
-        <value>sdl</value>
-        <value>vnc</value>
-        <value>spice</value>
-      </enum>
-    </graphics>
-    <video supported='yes'>
-      <enum name='modelType'>
-        <value>vga</value>
-        <value>cirrus</value>
-        <value>xen</value>
-      </enum>
-    </video>
-    <hostdev supported='yes'>
-      <enum name='mode'>
-        <value>subsystem</value>
-      </enum>
-      <enum name='startupPolicy'>
-        <value>default</value>
-        <value>mandatory</value>
-        <value>requisite</value>
-        <value>optional</value>
-      </enum>
-      <enum name='subsysType'>
-        <value>usb</value>
-        <value>pci</value>
-      </enum>
-      <enum name='capsType'/>
-      <enum name='pciBackend'>
-        <value>xen</value>
-      </enum>
-    </hostdev>
-  </devices>
-  <features>
-    <gic supported='no'/>
-    <vmcoreinfo supported='no'/>
-    <genid supported='no'/>
-    <sev supported='no'/>
-  </features>
-</domainCapabilities>
diff --git a/tests/domaincapsschemadata/libxl-xenpv.xml b/tests/domaincapsschemadata/libxl-xenpv.xml
index 6fc65f67b7..b9f3ca736b 100644
--- a/tests/domaincapsschemadata/libxl-xenpv.xml
+++ b/tests/domaincapsschemadata/libxl-xenpv.xml
@@ -50,6 +50,7 @@
         <value>optional</value>
       </enum>
       <enum name='subsysType'>
+        <value>usb</value>
         <value>pci</value>
       </enum>
       <enum name='capsType'/>
diff --git a/tests/domaincapstest.c b/tests/domaincapstest.c
index 7f52058bad..b9ab148fab 100644
--- a/tests/domaincapstest.c
+++ b/tests/domaincapstest.c
@@ -508,17 +508,9 @@ mymain(void)
 
 #if WITH_LIBXL
 
-# ifdef LIBXL_HAVE_PVUSB
-#  define LIBXL_XENPV_CAPS "libxl-xenpv-usb"
-#  define LIBXL_XENFV_CAPS "libxl-xenfv-usb"
-# else
-#  define LIBXL_XENPV_CAPS "libxl-xenpv"
-#  define LIBXL_XENFV_CAPS "libxl-xenfv"
-# endif
-
-    DO_TEST_LIBXL(LIBXL_XENPV_CAPS, "/usr/bin/qemu-system-x86_64",
+    DO_TEST_LIBXL("libxl-xenpv", "/usr/bin/qemu-system-x86_64",
                   "xenpv", "x86_64", VIR_DOMAIN_VIRT_XEN);
-    DO_TEST_LIBXL(LIBXL_XENFV_CAPS, "/usr/bin/qemu-system-x86_64",
+    DO_TEST_LIBXL("libxl-xenfv", "/usr/bin/qemu-system-x86_64",
                   "xenfv", "x86_64", VIR_DOMAIN_VIRT_XEN);
 
 #endif /* WITH_LIBXL */